=== test/pixi_build/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(test_pixi_build)
find_package(coal REQUIRED)
