=== debian/changelog ===
ros-one-coal (3.0.2-423jammy.20260227.2040) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Joseph Mirabel <jmirabel@laas.fr>  Fri, 27 Feb 2026 20:40:26 +0000
