=== debian/control ===
Source: ros-one-coal
Section: misc
Priority: optional
Maintainer: Joseph Mirabel <jmirabel@laas.fr>
Build-Depends: debhelper (>= 9.0.0), cmake, doxygen, git, libassimp-dev, libboost-all-dev, libeigen3-dev, liboctomap-dev, python3-dev, python3-lxml, python3-numpy, ros-one-eigenpy, ros-one-jrl-cmakemodules
Homepage: https://github.com/coal-library/coal
Standards-Version: 3.9.2

Package: ros-one-coal
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libassimp-dev, libboost-all-dev, libeigen3-dev, liboctomap-dev, python3-dev, python3-numpy, ros-one-catkin, ros-one-eigenpy
Description: An extension of the Flexible Collision Library.
