## ros-one-coal 3.0.2-423noble.20260227.2041

=== debian/changelog ===
ros-one-coal (3.0.2-423noble.20260227.2041) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Joseph Mirabel <jmirabel@laas.fr>  Fri, 27 Feb 2026 20:41:38 +0000
